## milvus-io__milvus_20260115T130435Z.zip

=== Makefile ===
# Copyright (C) 2019-2020 Zilliz. All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance
# with the License. You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software distributed under the License
# is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
# or implied. See the License for the specific language governing permissions and limitations under the License.

GO		  ?= go
PWD 	  := $(shell pwd)
GOPATH	:= $(shell $(GO) env GOPATH)
SHELL 	:= /bin/bash
OBJPREFIX := "github.com/milvus-io/milvus/cmd/milvus"
MILVUS_GO_BUILD_TAGS := "dynamic,sonic,with_jemalloc"

INSTALL_PATH := $(PWD)/bin
LIBRARY_PATH := $(PWD)/lib
PGO_PATH := $(PWD)/configs/pgo
OS := $(shell uname -s)
mode = Release

# Set disk_index default based on OS
# macOS (Darwin) does not support aio, so disable disk_index
ifeq ($(OS),Darwin)
    use_disk_index = OFF
    planparser_rpath_flag = -Wl,-rpath,@loader_path
else
    use_disk_index = ON
    planparser_rpath_flag = -Wl,-rpath,'$$ORIGIN'
endif

# Allow manual override via disk_index variable
ifdef disk_index
    use_disk_index = ${disk_index}
endif

use_asan = OFF
ifeq ($(USE_ASAN), ON)
	use_asan = ${USE_ASAN}
	CGO_LDFLAGS := $(shell go env CGO_LDFLAGS) -fno-stack-protector -fno-omit-frame-pointer -fno-var-tracking -fsanitize=address
	CGO_CFLAGS := $(shell go env CGO_CFLAGS) -fno-stack-protector -fno-omit-frame-pointer -fno-var-tracking -fsanitize=address
	MILVUS_GO_BUILD_TAGS := $(MILVUS_GO_BUILD_TAGS),use_asan
endif

use_dynamic_simd = ON
ifdef USE_DYNAMIC_SIMD
	use_dynamic_simd = ${USE_DYNAMIC_SIMD}
endif

tantivy_features = ""
ifdef TANTIVY_FEATURES
	tantivy_features = ${TANTIVY_FEATURES}
endif

use_opendal = OFF
ifdef USE_OPENDAL
	use_opendal = ${USE_OPENDAL}
endif
# golangci-lint
GOLANGCI_LINT_VERSION := 1.64.7
GOLANGCI_LINT_OUTPUT := $(shell $(INSTALL_PATH)/golangci-lint --version 2>/dev/null)
INSTALL_GOLANGCI_LINT := $(findstring $(GOLANGCI_LINT_VERSION), $(GOLANGCI_LINT_OUTPUT))
# mockery
MOCKERY_VERSION := 2.53.3
MOCKERY_OUTPUT := $(shell $(INSTALL_PATH)/mockery --version 2>/dev/null)
INSTALL_MOCKERY := $(findstring $(MOCKERY_VERSION),$(MOCKERY_OUTPUT))
# gci
GCI_VERSION := 0.11.2
GCI_OUTPUT := $(shell $(INSTALL_PATH)/gci --version 2>/dev/null)
INSTALL_GCI := $(findstring $(GCI_VERSION),$(GCI_OUTPUT))
# gofumpt
GOFUMPT_VERSION := 0.5.0
GOFUMPT_OUTPUT := $(shell $(INSTALL_PATH)/gofumpt --version 2>/dev/null)
INSTALL_GOFUMPT := $(findstring $(GOFUMPT_VERSION),$(GOFUMPT_OUTPUT))
# gotestsum
GOTESTSUM_VERSION := 1.11.0
GOTESTSUM_OUTPUT := $(shell $(INSTALL_PATH)/gotestsum --version 2>/dev/null)
INSTALL_GOTESTSUM := $(findstring $(GOTESTSUM_VERSION),$(GOTESTSUM_OUTPUT))
# protoc-gen-go
PROTOC_GEN_GO_VERSION := 1.33.0
PROTOC_GEN_GO_OUTPUT := $(shell echo | $(INSTALL_PATH)/protoc-gen-go --version 2>/dev/null)
INSTALL_PROTOC_GEN_GO := $(findstring $(PROTOC_GEN_GO_VERSION),$(PROTOC_GEN_GO_OUTPUT))
# protoc-gen-go-grpc
PROTOC_GEN_GO_GRPC_VERSION := 1.3.0
PROTOC_GEN_GO_GRPC_OUTPUT := $(shell echo | $(INSTALL_PATH)/protoc-gen-go-grpc  --version 2>/dev/null)
INSTALL_PROTOC_GEN_GO_GRPC := $(findstring $(PROTOC_GEN_GO_GRPC_VERSION),$(PROTOC_GEN_GO_GRPC_OUTPUT))

index_engine = knowhere

export GIT_BRANCH=master

ifeq (${ENABLE_AZURE}, false)
	AZURE_OPTION := -Z
endif

milvus: build-cpp print-build-info build-go

build-go:
	@echo "Building Milvus ..."
	@source $(PWD)/scripts/setenv.sh && \
		mkdir -p $(INSTALL_PATH) && go env -w CGO_ENABLED="1" && \
		CGO_LDFLAGS="$(CGO_LDFLAGS)" CGO_CFLAGS="$(CGO_CFLAGS)" GO111MODULE=on $(GO) build -pgo=$(PGO_PATH)/default.pgo -ldflags="-r $${RPATH} -X '$(OBJPREFIX).BuildTags=$(BUILD_TAGS)' -X '$(OBJPREFIX).BuildTime=$(BUILD_TIME)' -X '$(OBJPREFIX).GitCommit=$(GIT_COMMIT)' -X '$(OBJPREFIX).GoVersion=$(GO_VERSION)'" \
		-tags $(MILVUS_GO_BUILD_TAGS) -o $(INSTALL_PATH)/milvus $(PWD)/cmd/main.go 1>/dev/null

milvus-gpu: build-cpp-gpu print-gpu-build-info
	@echo "Building Milvus-gpu ..."
	@source $(PWD)/scripts/setenv.sh && \
		mkdir -p $(INSTALL_PATH) && go env -w CGO_ENABLED="1" && \
		CGO_LDFLAGS="$(CGO_LDFLAGS)" CGO_CFLAGS="$(CGO_CFLAGS)" GO111MODULE=on $(GO) build -pgo=$(PGO_PATH)/default.pgo -ldflags="-r $${RPATH} -X '$(OBJPREFIX).BuildTags=$(BUILD_TAGS_GPU)' -X '$(OBJPREFIX).BuildTime=$(BUILD_TIME)' -X '$(OBJPREFIX).GitCommit=$(GIT_COMMIT)' -X '$(OBJPREFIX).GoVersion=$(GO_VERSION)'" \
		-tags "$(MILVUS_GO_BUILD_TAGS),cuda" -o $(INSTALL_PATH)/milvus $(PWD)/cmd/main.go 1>/dev/null

get-build-deps:
	@(env bash $(PWD)/scripts/install_deps.sh)

# attention: upgrade golangci-lint should also change Dockerfiles in build/docker/builder/cpu/<os>
getdeps:
	@mkdir -p $(INSTALL_PATH)
	@if [ -z "$(INSTALL_GOLANGCI_LINT)" ]; then \
		echo "Installing golangci-lint into ./bin/" && curl -sSfL https://raw.githubusercontent.com/golangci/golangci-lint/master/install.sh | sh -s -- -b $(INSTALL_PATH) v${GOLANGCI_LINT_VERSION} ; \
	else \
		echo "golangci-lint v@$(GOLANGCI_LINT_VERSION) already installed"; \
	fi
	@if [ -z "$(INSTALL_MOCKERY)" ]; then \
		echo "Installing mockery v$(MOCKERY_VERSION) to ./bin/" && GOBIN=$(INSTALL_PATH) go install github.com/vektra/mockery/v2@v$(MOCKERY_VERSION); \
	else \
		echo "Mockery v$(MOCKERY_VERSION) already installed"; \
	fi
	@if [ -z "$(INSTALL_GOTESTSUM)" ]; then \
		echo "Install gotestsum v$(GOTESTSUM_VERSION) to ./bin/" && GOBIN=$(INSTALL_PATH) go install -ldflags="-X 'gotest.tools/gotestsum/cmd.version=$(GOTESTSUM_VERSION)'" gotest.tools/gotestsum@v$(GOTESTSUM_VERSION); \
	else \
		echo "gotestsum v$(GOTESTSUM_VERSION) already installed";\
	fi

get-proto-deps:
	@mkdir -p $(INSTALL_PATH) # make sure directory exists
	@if [ -z "$(INSTALL_PROTOC_GEN_GO)" ]; then \
		echo "install protoc-gen-go $(PROTOC_GEN_GO_VERSION) to $(INSTALL_PATH)" && GOBIN=$(INSTALL_PATH) go install google.golang.org/protobuf/cmd/protoc-gen-go@v$(PROTOC_GEN_GO_VERSION); \
	else \
		echo "protoc-gen-go@v$(PROTOC_GEN_GO_VERSION) already installed";\
	fi
	@if [ -z "$(INSTALL_PROTOC_GEN_GO_GRPC)" ]; then \
		echo "install protoc-gen-go-grpc $(PROTOC_GEN_GO_GRPC_VERSION) to $(INSTALL_PATH)" && GOBIN=$(INSTALL_PATH) go install google.golang.org/grpc/cmd/protoc-gen-go-grpc@v$(PROTOC_GEN_GO_GRPC_VERSION); \
	else \
		echo "protoc-gen-go-grpc@v$(PROTOC_GEN_GO_GRPC_VERSION) already installed";\
	fi

tools/bin/revive: tools/check/go.mod
	cd tools/check; \
	$(GO) build -pgo=$(PGO_PATH)/default.pgo -o ../bin/revive github.com/mgechev/revive

cppcheck:
	@#(env bash ${PWD}/scripts/core_build.sh -l)
	@(env bash ${PWD}/scripts/check_cpp_fmt.sh)

rustfmt:
	@echo  "Running cargo format"
	@env bash ${PWD}/scripts/run_cargo_format.sh ${PWD}/internal/core/thirdparty/tantivy/tantivy-binding/

rustcheck:
	@echo  "Running cargo check"
	@env bash ${PWD}/scripts/run_cargo_format.sh ${PWD}/internal/core/thirdparty/tantivy/tantivy-binding/ --check

fmt:
ifdef GO_DIFF_FILES
	@echo "Running $@ check"
	@GO111MODULE=on env bash $(PWD)/scripts/gofmt.sh $(GO_DIFF_FILES)
else
	@echo "Running $@ check"
	@GO111MODULE=on env bash $(PWD)/scripts/gofmt.sh cmd/
	@GO111MODULE=on env bash $(PWD)/scripts/gofmt.sh internal/
	@GO111MODULE=on env bash $(PWD)/scripts/gofmt.sh tests/integration/
	@GO111MODULE=on env bash $(PWD)/scripts/gofmt.sh tests/go/
	@GO111MODULE=on env bash $(PWD)/scripts/gofmt.sh pkg/
endif

lint-fix: getdeps
	@mkdir -p $(INSTALL_PATH)
	@if [ -z "$(INSTALL_GCI)" ]; then \
		echo "Installing gci v$(GCI_VERSION) to ./bin/" && GOBIN=$(INSTALL_PATH) go install github.com/daixiang0/gci@v$(GCI_VERSION); \
	else \
		echo "gci v$(GCI_VERSION) already installed"; \
	fi
	@if [ -z "$(INSTALL_GOFUMPT)" ]; then \
		echo "Installing gofumpt v$(GOFUMPT_VERSION) to ./bin/" && GOBIN=$(INSTALL_PATH) go install mvdan.cc/gofumpt@v$(GOFUMPT_VERSION); \
	else \
		echo "gofumpt v$(GOFUMPT_VERSION) already installed"; \
	fi
	@echo "Running gofumpt fix"
	@$(INSTALL_PATH)/gofumpt -l -w internal/
	@$(INSTALL_PATH)/gofumpt -l -w cmd/
	@$(INSTALL_PATH)/gofumpt -l -w pkg/
	@$(INSTALL_PATH)/gofumpt -l -w client/
	@$(INSTALL_PATH)/gofumpt -l -w tests/go_client/
	@$(INSTALL_PATH)/gofumpt -l -w tests/integration/
	@echo "Running gci fix"
	@$(INSTALL_PATH)/gci write cmd/ --skip-generated -s standard -s default -s "prefix(github.com/milvus-io)" --custom-order
	@$(INSTALL_PATH)/gci write internal/ --skip-generated -s standard -s default -s "prefix(github.com/milvus-io)" --custom-order
	@$(INSTALL_PATH)/gci write pkg/ --skip-generated -s standard -s default -s "prefix(github.com/milvus-io)" --custom-order
	@$(INSTALL_PATH)/gci write client/ --skip-generated -s standard -s default -s "prefix(github.com/milvus-io)" --custom-order
	@$(INSTALL_PATH)/gci write tests/ --skip-generated -s standard -s default -s "prefix(github.com/milvus-io)" --custom-order
	@echo "Running golangci-lint auto-fix"
	@source $(PWD)/scripts/setenv.sh && GO111MODULE=on $(INSTALL_PATH)/golangci-lint run --fix --timeout=30m --config $(PWD)/.golangci.yml; 
	@source $(PWD)/scripts/setenv.sh && cd pkg && GO111MODULE=on $(INSTALL_PATH)/golangci-lint run --fix --timeout=30m --config $(PWD)/.golangci.yml
	@source $(PWD)/scripts/setenv.sh && cd client && GO111MODULE=on $(INSTALL_PATH)/golangci-lint run --fix --timeout=30m --config $(PWD)/client/.golangci.yml

#TODO: Check code specifications by golangci-lint
static-check: getdeps
	@echo "Running $@ check"
	@echo "Start check core packages"
	@source $(PWD)/scripts/setenv.sh && GO111MODULE=on GOFLAGS=-buildvcs=false $(INSTALL_PATH)/golangci-lint run --build-tags dynamic,test --timeout=30m --config $(PWD)/.golangci.yml
	@echo "Start check pkg package"
	@source $(PWD)/scripts/setenv.sh && cd pkg && GO111MODULE=on GOFLAGS=-buildvcs=false $(INSTALL_PATH)/golangci-lint run --build-tags dynamic,test --timeout=30m --config $(PWD)/.golangci.yml
	@echo "Start check client package"
	@source $(PWD)/scripts/setenv.sh && cd client && GO111MODULE=on GOFLAGS=-buildvcs=false $(INSTALL_PATH)/golangci-lint run --timeout=30m --config $(PWD)/client/.golangci.yml
	@echo "Start check go_client e2e package"
	@source $(PWD)/scripts/setenv.sh && cd tests/go_client && GO111MODULE=on GOFLAGS=-buildvcs=false $(INSTALL_PATH)/golangci-lint run --build-tags L0,L1,L2,test --timeout=30m --config $(PWD)/tests/go_client/.golangci.yml

verifiers: build-cpp getdeps cppcheck rustcheck fmt static-check

# Build various components locally.
binlog:
	@echo "Building binlog ..."
	@source $(PWD)/scripts/setenv.sh && \
		mkdir -p $(INSTALL_PATH) && go env -w CGO_ENABLED="1" && \
		GO111MODULE=on $(GO) build -pgo=$(PGO_PATH)/default.pgo -ldflags="-r $${RPATH}" -o $(INSTALL_PATH)/binlog $(PWD)/cmd/tools/binlog/main.go 1>/dev/null

MIGRATION_PATH = $(PWD)/cmd/tools/migration
meta-migration:
	@echo "Building migration tool ..."
	@source $(PWD)/scripts/setenv.sh && \
    		mkdir -p $(INSTALL_PATH) && go env -w CGO_ENABLED="1" && \
    		GO111MODULE=on $(GO) build -pgo=$(PGO_PATH)/default.pgo -ldflags="-r $${RPATH} -X '$(OBJPREFIX).BuildTags=$(BUILD_TAGS)' -X '$(OBJPREFIX).BuildTime=$(BUILD_TIME)' -X '$(OBJPREFIX).GitCommit=$(GIT_COMMIT)' -X '$(OBJPREFIX).GoVersion=$(GO_VERSION)'" \
    		-tags dynamic -o $(INSTALL_PATH)/meta-migration $(MIGRATION_PATH)/main.go 1>/dev/null

INTERATION_PATH = $(PWD)/tests/integration
integration-test: getdeps
	@echo "Building integration tests ..."
	@(env bash $(PWD)/scripts/run_intergration_test.sh "$(INSTALL_PATH)/gotestsum --")

BUILD_TAGS = $(shell git describe --tags --always --dirty="-dev")
BUILD_TAGS_GPU = ${BUILD_TAGS}-gpu
BUILD_TIME = $(shell date -u)
GIT_COMMIT = $(shell git rev-parse --short HEAD)
GO_VERSION = $(shell go version)

print-build-info:
	$(shell git config --global --add safe.directory '*')
	@echo "Build Tag: $(BUILD_TAGS)"
	@echo "Build Time: $(BUILD_TIME)"
	@echo "Git Commit: $(GIT_COMMIT)"
	@echo "Go Version: $(GO_VERSION)"

print-gpu-build-info:

=== tests/python_client/requirements.txt ===
--extra-index-url https://test.pypi.org/simple/
pytest-cov==2.8.1
requests>=2.32.4
scikit-learn>=1.5.2
timeout_decorator==0.5.0
ujson==5.5.0
pytest==8.3.4
pytest-asyncio==0.24.0
pytest-assume==2.4.3
pytest-timeout==1.3.3
pytest-repeat==0.8.0
allure-pytest==2.7.0
pytest-print==0.2.1
pytest-level==0.1.1
pytest-xdist==2.5.0

pytest-rerunfailures==14.0
pytest_tagging==1.6.0
ndg-httpsclient
pyopenssl
pyasn1
pytest-html==3.1.1
delayed-assert==0.3.5
kubernetes==17.17.0
PyYAML==6.0
pytest-sugar==0.9.5
pytest-parallel
pytest-random-order

# pymilvus
pymilvus==2.7.0rc110
pymilvus[bulk_writer]==2.7.0rc110
# for protobuf
protobuf>=5.29.5

# for customize config test
python-benedict==0.24.3
timeout-decorator==0.5.0

# for bulk insert test
minio==7.2.0
npy-append-array==0.9.15
Faker==19.2.0

# for benchmark
h5py==3.8.0

# for log
loguru==0.7.0

# util
psutil==5.9.4
pandas==1.5.3
numpy==1.26.4
tenacity==8.1.0
rich==13.7.0
# for standby test
etcd-sdk-python==0.0.6
deepdiff==8.6.1

# for test result analyzer
prettytable==3.8.0
pyarrow==14.0.1
fastparquet==2023.7.0

# for bf16 datatype
ml-dtypes==0.2.0

# for full text search
tantivy==0.22.0
bm25s==0.2.0
jieba==0.42.1
Unidecode==1.3.8


# for perf test
locust==2.25.0

# for supporting higher python version
typing_extensions==4.12.2

# for env configuration
python-dotenv<=2.0.0

# for geometry
shapely==2.1.1

# for time zone
tzdata>=2024.1

=== tests/restful_client/requirements.txt ===
--extra-index-url https://test.pypi.org/simple/
requests>=2.32.4
urllib3>=2.5.0
pytest==7.2.0
pytest-assume==2.4.3
pytest-timeout==1.3.3
pytest-repeat==0.8.0
allure-pytest>=2.8.18
pytest-print==0.2.1
pytest-level==0.1.1
pytest-xdist==2.5.0
pytest-html==3.1.1
pytest-sugar==0.9.5
pytest-parallel
pytest-random-order
PyYAML==6.0
numpy==1.24.3
Faker==19.2.0
pymilvus==2.4.0rc19
scikit-learn>=1.5.2
tenacity==8.1.0

=== tests/restful_client_v2/requirements.txt ===
--extra-index-url https://test.pypi.org/simple/
requests>=2.32.4
urllib3>=2.5.0
pytest==7.2.0
pyyaml==6.0
numpy==1.24.3
allure-pytest>=2.8.18
Faker==19.2.0
pymilvus
scikit-learn>=1.5.2
pytest-xdist==2.5.0
minio==7.2.0
tenacity==8.1.0
# for bf16 datatype
ml-dtypes==0.2.0
loguru==0.7.3
bm25s==0.2.13
jieba==0.42.1
pyarrow==21.0.0
# for geometry data type
shapely>=2.0.0

=== internal/core/unittest/CMakeLists.txt ===
# Copyright (C) 2019-2020 Zilliz. All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance
# with the License. You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software distributed under the License
# is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
# or implied. See the License for the specific language governing permissions and limitations under the License

include_directories(${CMAKE_HOME_DIRECTORY}/src)
include_directories(${CMAKE_HOME_DIRECTORY}/src/thirdparty)
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(
    ${KNOWHERE_INCLUDE_DIR}
    ${SIMDJSON_INCLUDE_DIR}
    ${TANTIVY_INCLUDE_DIR}
    ${CONAN_INCLUDE_DIRS}
    ${MILVUS_COMMON_INCLUDE_DIR}
    ${MILVUS_STORAGE_INCLUDE_DIR}
)

add_definitions(-DMILVUS_TEST_SEGCORE_YAML_PATH="${CMAKE_CURRENT_SOURCE_DIR}/test_utils/test_segcore.yaml")

# Collect test files from source directories using glob pattern
file(GLOB_RECURSE SOURCE_TEST_FILES
    "${CMAKE_HOME_DIRECTORY}/src/**/*Test.cpp"
    "${CMAKE_HOME_DIRECTORY}/src/**/*_test.cpp"
)

# TODO: better to use ls/find pattern
set(MILVUS_TEST_FILES
        ${SOURCE_TEST_FILES}
        init_gtest.cpp
        test_loading.cpp
        test_exec.cpp
        test_expr_materialized_view.cpp
        test_float16.cpp
        test_search_group_by.cpp
        test_iterative_filter.cpp
        test_indexing.cpp
        test_index_wrapper.cpp
        test_integer_overflow.cpp
        test_query.cpp
        test_scorer.cpp
        test_sealed.cpp
        test_storage.cpp
        test_string_expr.cpp
        test_rust_result.cpp
        test_storage_v2_index_raw_data.cpp
        test_group_by_json.cpp
        test_element_filter.cpp
        test_query_group_by.cpp
        test_minhash.cpp
        )

if ( NOT (INDEX_ENGINE STREQUAL "cardinal") )
    list(FILTER MILVUS_TEST_FILES EXCLUDE REGEX "KmeansClusteringTest\\.cpp$")
endif()

# need update aws-sdk-cpp, see more from https://github.com/aws/aws-sdk-cpp/issues/1757.
# now we always remove this file from MILVUS_TEST_FILES thus it is never compiled.
# once done, compile this test file only if `BUILD_DISK_ANN STREQUAL "ON"`.
# if ( BUILD_DISK_ANN STREQUAL "OFF" )
    list(FILTER MILVUS_TEST_FILES EXCLUDE REGEX "MinioChunkManagerTest\\.cpp$")
# endif()

# bitset has its own test binary
list(FILTER MILVUS_TEST_FILES EXCLUDE REGEX "BitsetTest\\.cpp$")

if (NOT (LINUX OR APPLE))
    list(FILTER MILVUS_TEST_FILES EXCLUDE REGEX "ScalarIndexCreatorTest\\.cpp$")
    list(FILTER MILVUS_TEST_FILES EXCLUDE REGEX "StringIndexTest\\.cpp$")
    list(FILTER MILVUS_TEST_FILES EXCLUDE REGEX "ArrayTest\\.cpp$")
    list(FILTER MILVUS_TEST_FILES EXCLUDE REGEX "ExprArrayTest\\.cpp$")
endif()

if (ENABLE_AZURE_FS)
    set(AZURE_BUILD_DIR ON)
    add_definitions(-DAZURE_BUILD_DIR)
else()
    list(FILTER MILVUS_TEST_FILES EXCLUDE REGEX "AzureChunkManagerTest\\.cpp$")
    list(FILTER MILVUS_TEST_FILES EXCLUDE REGEX "AzureBlobChunkManagerTest\\.cpp$")
endif()
# need update aws-sdk-cpp, see more from https://github.com/aws/aws-sdk-cpp/issues/2119
# once done, move this line to the else branch of `if (DEFINED AZURE_BUILD_DIR)`
list(FILTER MILVUS_TEST_FILES EXCLUDE REGEX "RemoteChunkManagerTest\\.cpp$")

if (ENABLE_GCP_NATIVE)
    add_definitions(-DENABLE_GCP_NATIVE)
else()
    list(FILTER MILVUS_TEST_FILES EXCLUDE REGEX "GcpNativeChunkManagerTest\\.cpp$")
endif()

if (LINUX)
    message( STATUS "Building Milvus Unit Test on Linux")
    option(USE_ASAN "Whether to use AddressSanitizer" OFF)
    if ( USE_ASAN )
        message( STATUS "Building Milvus using AddressSanitizer")
        add_compile_options(-fno-stack-protector -fno-omit-frame-pointer -fno-var-tracking -fsanitize=address)
        add_link_options(-fno-stack-protector -fno-omit-frame-pointer -fno-var-tracking -fsanitize=address)
    endif()
endif()

add_executable(all_tests
        ${MILVUS_TEST_FILES}
        )

target_link_libraries(all_tests
        gtest
        gmock
        milvus_core
        knowhere
        milvus-storage
        milvus-common
        )

install(TARGETS all_tests DESTINATION unittest)

add_subdirectory(bench)
add_subdirectory(test_json_stats)

# bitset unit test
include(CheckCXXCompilerFlag)
include(CheckIncludeFileCXX)

check_cxx_compiler_flag("-march=armv8-a+sve" COMPILER_SUPPORTS_SVE)
check_include_file_cxx("arm_sve.h" COMPILER_HAS_ARM_SVE_HEADER)

add_executable(bitset_test
        ${CMAKE_HOME_DIRECTORY}/src/bitset/BitsetTest.cpp
)

if (COMPILER_SUPPORTS_SVE AND COMPILER_HAS_ARM_SVE_HEADER)
        message(STATUS "SVE support for the bitset library UT is enabled")
        target_compile_definitions(bitset_test PRIVATE BITSET_ENABLE_SVE_SUPPORT=1)

        set_source_files_properties(${CMAKE_HOME_DIRECTORY}/src/bitset/BitsetTest.cpp PROPERTIES COMPILE_FLAGS "-march=armv8-a+sve")
else()
        message(STATUS "SVE support for the bitset library UT is disabled")
endif()

target_link_libraries(bitset_test
        milvus_bitset
        gtest
        ${CONAN_LIBS}
)
install(TARGETS bitset_test DESTINATION unittest)

=== tests/python_client/chaos/requirements.txt ===

# for test result analyzer
prettytable==3.8.0
pyarrow==14.0.1

=== tests/python_client/data_verify/requirements.txt ===
pymilvus>=2.5.11
pymilvus-pg==0.1.3

=== tests/python_client/deploy/requirements.txt ===
--extra-index-url https://test.pypi.org/simple/
docker==5.0.0
grpcio==1.53.2
grpcio-tools==1.37.1
pymilvus==2.0.0rc8

# for test result anaylszer
prettytable==3.8.0
pyarrow==14.0.1
fastparquet==2023.7.0

=== internal/core/src/clustering/CMakeLists.txt ===
# Copyright (C) 2019-2020 Zilliz. All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance
# with the License. You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software distributed under the License
# is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
# or implied. See the License for the specific language governing permissions and limitations under the License

add_source_at_current_directory_recursively()
add_library(milvus_clustering OBJECT ${SOURCE_FILES})

=== internal/core/src/common/CMakeLists.txt ===
# Copyright (C) 2019-2020 Zilliz. All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance
# with the License. You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software distributed under the License
# is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
# or implied. See the License for the specific language governing permissions and limitations under the License

add_source_at_current_directory_recursively()
add_library(milvus_common OBJECT ${SOURCE_FILES})

=== internal/core/src/index/CMakeLists.txt ===
# Copyright (C) 2019-2020 Zilliz. All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance
# with the License. You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software distributed under the License
# is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
# or implied. See the License for the specific language governing permissions and limitations under the License

add_source_at_current_directory_recursively()
add_library(milvus_index OBJECT ${SOURCE_FILES})

=== internal/core/src/minhash/CMakeLists.txt ===
# Copyright (C) 2019-2025 Zilliz. All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance
# with the License. You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software distributed under the License
# is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
# or implied. See the License for the specific language governing permissions and limitations under the License

# MinHash module build configuration
add_source_at_current_directory_recursively()

# Separate SIMD implementation files from main source
list(FILTER SOURCE_FILES EXCLUDE REGEX "fusion_compute/x86/.*")
list(FILTER SOURCE_FILES EXCLUDE REGEX "fusion_compute/arm/.*")

add_library(milvus_minhash OBJECT ${SOURCE_FILES})

# Build strategy: Compile all SIMD variants unconditionally
# This ensures build/deploy machine separation - binary contains all variants
# Runtime CPU detection will select the optimal implementation based on actual hardware

if(CMAKE_SYSTEM_PROCESSOR MATCHES "(x86)|(X86)|(amd64)|(AMD64)")
    # Unconditionally compile AVX2 variant
    set(AVX2_SOURCES
        ${CMAKE_CURRENT_SOURCE_DIR}/fusion_compute/x86/fusion_compute_avx2.cpp
    )
    set_source_files_properties(${AVX2_SOURCES} PROPERTIES COMPILE_FLAGS "-mavx2 -mfma")
    target_sources(milvus_minhash PRIVATE ${AVX2_SOURCES})
    message(STATUS "Building with AVX2 support")

    # Unconditionally compile AVX512 variant
    set(AVX512_SOURCES
        ${CMAKE_CURRENT_SOURCE_DIR}/fusion_compute/x86/fusion_compute_avx512.cpp
    )
    set_source_files_properties(${AVX512_SOURCES} PROPERTIES COMPILE_FLAGS "-mavx512f -mavx512dq -mavx512bw -mavx512vl")
    target_sources(milvus_minhash PRIVATE ${AVX512_SOURCES})
    message(STATUS "Building with AVX512 support")

elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "(aarch64)|(ARM64)")
    # Unconditionally compile NEON variant
    set(NEON_SOURCES
        ${CMAKE_CURRENT_SOURCE_DIR}/fusion_compute/arm/fusion_compute_neon.cpp
    )
    target_sources(milvus_minhash PRIVATE ${NEON_SOURCES})
    message(STATUS "Building with NEON support")

    # Unconditionally compile SVE variant
    set(SVE_SOURCES
        ${CMAKE_CURRENT_SOURCE_DIR}/fusion_compute/arm/fusion_compute_sve.cpp
    )
    set_source_files_properties(${SVE_SOURCES} PROPERTIES COMPILE_FLAGS "-march=armv8-a+sve")
    target_sources(milvus_minhash PRIVATE ${SVE_SOURCES})
    message(STATUS "Building with SVE support")
endif()

target_link_libraries(milvus_minhash PUBLIC
    xxhash::xxhash
    OpenSSL::SSL
)

target_include_directories(milvus_minhash PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}/..
    ${CMAKE_CURRENT_SOURCE_DIR}/fusion_compute
)

=== build/deb/debian/control ===
Source: milvus
Section: devel
Priority: optional
Maintainer: Yunmei Li <yunmei.li@zilliz.com>
Build-Depends: debhelper (>= 10), gcc (>= 7.5), g++ (>= 7.5) 
Standards-Version: 4.1.2
Homepage: https://github.com/milvus-io/milvus

Package: milvus
Architecture: any-amd64
Depends: ${shlibs:Depends}, ${misc:Depends}, tzdata
Description: An open-source vector dstabase for unstructured data.
  Milvus was created in 2019 with a singular goal: store, index, and manage massive embedding vectors generated by deep neural networks and other machine learning (ML) models.

=== build/deb/debian/rules ===
#!/usr/bin/make -f
export HOME = $(CURDIR)
%:
	dh $@

override_dh_auto_build:
	echo "skip build"	

override_dh_auto_install:
	mkdir -p $(PWD)/debian/milvus/usr/bin
	mkdir -p $(PWD)/debian/milvus/usr/lib/milvus/
	mkdir -p $(PWD)/debian/milvus/etc/milvus/configs/advanced
	mkdir -p $(PWD)/debian/milvus/lib/systemd/system
	mkdir -p $(PWD)/debian/milvus/etc/ld.so.conf.d
	cp -f $(PWD)/milvus-bin/milvus $(PWD)/debian/milvus/usr/bin/
	cp -P -r $(PWD)/milvus-lib/* $(PWD)/debian/milvus/usr/lib/milvus/
	cp -r $(PWD)/configs/advanced/* $(PWD)/debian/milvus/etc/milvus/configs/advanced/
	cp $(PWD)/configs/milvus.yaml $(PWD)/debian/milvus/etc/milvus/configs/
	cp $(PWD)/configs/glog.conf $(PWD)/debian/milvus/etc/milvus/configs/
	cp $(PWD)/configs/embedEtcd.yaml $(PWD)/debian/milvus/etc/milvus/configs/
	cp $(PWD)/scripts/milvus.conf $(PWD)/debian/milvus/etc/ld.so.conf.d/
	cp $(PWD)/scripts/milvus.service $(PWD)/debian/milvus/lib/systemd/system/

override_dh_shlibdeps:
	dh_shlibdeps -l$(shell pwd)/milvus-lib
